"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const operators_1 = require("rxjs/operators");
const lodash_1 = require("lodash");
function hears(rawKeywords, eventType) {
    return (source) => source.pipe(operators_1.filter(ev => {
        if (eventType === 'message' && !ev.message) {
            return false;
        }
        else if (eventType === 'postback' && !ev.postback) {
            return false;
        }
        const value = lodash_1.get(ev, 'postback.payload') || lodash_1.get(ev, 'message.quick_reply.payload') || lodash_1.get(ev, 'message.text');
        if (!value) {
            return false;
        }
        if (typeof rawKeywords === 'function') {
            return rawKeywords(value);
        }
        const keywords = Array.isArray(rawKeywords) ? rawKeywords : [rawKeywords];
        return keywords.some(keyword => value.toLowerCase().includes(keyword.toLowerCase()));
    }));
}
exports.hears = hears;
